Attribute VB_Name = "geom"
Public Const Pi = 3.1415

Public Function Milieu(A As point, B As point) As point
Set Milieu = New point
Milieu.x = (A.x + B.x) / 2
Milieu.y = (A.y + B.y) / 2
End Function

Public Function Distance(A As point, B As point) As Currency
Distance = Sqr(CDbl(((A.x - B.x) ^ 2) + (A.y - B.y) ^ 2))
End Function

'intersection de (AB) et de (CD)
Public Function Intersection(A As point, B As point, c As point, D As point) As point
Dim D1 As New droite
Dim D2 As New droite
Dim lambda As Currency

Set Intersection = New point

D1.koi = dbipoint
Set D1.A = A
Set D1.B = B
D1.Calculer_coef

D2.koi = dbipoint
Set D2.A = c
Set D2.B = D
D2.Calculer_coef

'si les 2 droites sont paralleles
'pas d'intersection
If (D2.c_a * (B.x - A.x) + D2.c_b * (B.y - A.y)) = 0 Then
Intersection.exist = False
Exit Function
End If

'meme technique
'M(l) = (1-l)A + lB
'on cherche pour quel lambda M(lambda)  (CD)
lambda = (D2.c_c - (A.x * D2.c_a) - (D2.c_b * A.y)) / (D2.c_a * (B.x - A.x) + D2.c_b * (B.y - A.y))

Intersection.exist = True
Intersection.x = (1 - lambda) * A.x + lambda * B.x
Intersection.y = (1 - lambda) * A.y + lambda * B.y

End Function

Public Function Egal(A As point, B As point) As Boolean
Egal = True
If A.x <> B.x Then Egal = False
If A.y <> B.y Then Egal = False
End Function
